//
//     Xor block HEM
//                        
// Minimal HEM SDK version: 0.35
// Minimal Hiew version:    7.45
//
//     12 May 2007 - 1.00
//

#include "hem.h"

////////////////////////////////////////////////////////////

#define VER_MAJOR               1
#define VER_MINOR               00

////////////////////////////////////////////////////////////

int HEM_API
 Hem_Unload( void ),
 Hem_EntryPoint( HEMCALL_TAG *hemCall );

////////////////////////////////////////////////////////////

HEMINFO_TAG
  hemInfo = { sizeof( HEMINFO_TAG ), 
              sizeof( int ),
              0,                   // reserved
              HEM_SDK_VERSION_MAJOR, HEM_SDK_VERSION_MINOR,
              VER_MAJOR,             VER_MINOR,
              HEM_FLAG_MARKEDBLOCK | HEM_FLAG_HEX | HEM_FLAG_CODE | HEM_FLAG_FILEMASK,
              0,                   // reserved
              Hem_EntryPoint,
              NULL,
              NULL,
              0,                   // reserved
              0,                   // reserved
              0,                   // reserved
              0,                   // reserved
              "Xor block",
              "Xor block",
              "",
              "Xor block (c)SEN",
              "" };

////////////////////////////////////////////////////////////

int HEM_EXPORT
 Hem_Load( HIEWINFO_TAG *hiewInfo )
{
 HiewGate_Set( hiewInfo );
 hiewInfo->hemInfo = &hemInfo;
 return( ( hiewInfo->hiewVerMajor * 100 + hiewInfo->hiewVerMinor < 745 )? HEM_ERR_HIEW_VERSION_INVALID : HEM_OK );
}

////////////////////////////////////////////////////////////

#define     BLOCK_MAX                 16*1024*1024
#define     XORLINE_MAX               20
HEM_BYTE    xorLine[ XORLINE_MAX ];
int         xorLineLen              = 0;
int         bOnHexLine              = 0;

int HEM_API
 Hem_EntryPoint( HEMCALL_TAG *hemCall )
{
 HIEWGATE_GETDATA  hiewData;
 int  rc = HiewGate_GetData( &hiewData );
 if( rc == HEM_OK ){
   if( hiewData.sizeMark > BLOCK_MAX ){
     rc = HiewGate_SetErrorMsg( "Block too big" );
   }else{
     int  blockSize = (int)hiewData.sizeMark;
     if( ( rc = HiewGate_GetStringDual( "Enter Xor mask", xorLine, XORLINE_MAX, xorLineLen, &bOnHexLine ) ) > 0 ){
       xorLineLen = rc;
       rc = HiewGate_FileOpenForWrite();
       if( rc == HEM_OK ){
         HEM_BYTE  *pBlock = HiewGate_GetMemory( blockSize );
         if( pBlock == NULL )
           rc = HiewGate_SetErrorMsg( "GetMemory() error" );
          else{
           if( HiewGate_FileRead( hiewData.offsetMark1, blockSize, pBlock ) != blockSize )
             rc = HiewGate_SetErrorMsg( "Read() error" );
            else{
             HEM_BYTE  *p = pBlock;
             int  i = 0, n;
             for( n = 0; n < blockSize; n++ ){
               *p++ ^= xorLine[ i++ ];
               if( i >= xorLineLen )
                 i = 0;
             }
             rc = HiewGate_FileWrite( hiewData.offsetMark1, blockSize, pBlock );
           }
           HiewGate_FreeMemory( pBlock );
         }
       }
     }
   }
 }
 if( rc == HEM_OK )
   hemCall->returnActionFlag = HEM_RETURN_FILERELOAD;
 return( rc );
}

/// End of module //////////////////////////////////////////

